/**
 * Copyright (c) 2014 CEA LIST.
 * 
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 */
package org.eclipse.papyrusrt.codegen.cpp.profile.RTCppProperties;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.papyrusrt.codegen.cpp.profile.RTCppProperties.RTCppPropertiesPackage
 * @generated
 */
public interface RTCppPropertiesFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RTCppPropertiesFactory eINSTANCE = org.eclipse.papyrusrt.codegen.cpp.profile.RTCppProperties.impl.RTCppPropertiesFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Passive Class Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Passive Class Properties</em>'.
	 * @generated
	 */
	PassiveClassProperties createPassiveClassProperties();

	/**
	 * Returns a new object of class '<em>Attribute Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Attribute Properties</em>'.
	 * @generated
	 */
	AttributeProperties createAttributeProperties();

	/**
	 * Returns a new object of class '<em>Capsule Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Capsule Properties</em>'.
	 * @generated
	 */
	CapsuleProperties createCapsuleProperties();

	/**
	 * Returns a new object of class '<em>Dependency Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Dependency Properties</em>'.
	 * @generated
	 */
	DependencyProperties createDependencyProperties();

	/**
	 * Returns a new object of class '<em>Enumeration Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Enumeration Properties</em>'.
	 * @generated
	 */
	EnumerationProperties createEnumerationProperties();

	/**
	 * Returns a new object of class '<em>Operation Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Operation Properties</em>'.
	 * @generated
	 */
	OperationProperties createOperationProperties();

	/**
	 * Returns a new object of class '<em>Type Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Type Properties</em>'.
	 * @generated
	 */
	TypeProperties createTypeProperties();

	/**
	 * Returns a new object of class '<em>Parameter Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Parameter Properties</em>'.
	 * @generated
	 */
	ParameterProperties createParameterProperties();

	/**
	 * Returns a new object of class '<em>Generelization Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Generelization Properties</em>'.
	 * @generated
	 */
	GenerelizationProperties createGenerelizationProperties();

	/**
	 * Returns a new object of class '<em>RTS Attribute Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>RTS Attribute Properties</em>'.
	 * @generated
	 */
	RTSAttributeProperties createRTSAttributeProperties();

	/**
	 * Returns a new object of class '<em>RTS Abstract Attribute Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>RTS Abstract Attribute Properties</em>'.
	 * @generated
	 */
	RTSAbstractAttributeProperties createRTSAbstractAttributeProperties();

	/**
	 * Returns a new object of class '<em>RTS Descriptor Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>RTS Descriptor Properties</em>'.
	 * @generated
	 */
	RTSDescriptorProperties createRTSDescriptorProperties();

	/**
	 * Returns a new object of class '<em>RTS Class Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>RTS Class Properties</em>'.
	 * @generated
	 */
	RTSClassProperties createRTSClassProperties();

	/**
	 * Returns a new object of class '<em>RTS Classifier Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>RTS Classifier Properties</em>'.
	 * @generated
	 */
	RTSClassifierProperties createRTSClassifierProperties();

	/**
	 * Returns a new object of class '<em>RTS Enumeration Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>RTS Enumeration Properties</em>'.
	 * @generated
	 */
	RTSEnumerationProperties createRTSEnumerationProperties();

	/**
	 * Returns a new object of class '<em>RTS Enumeration Literal Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>RTS Enumeration Literal Properties</em>'.
	 * @generated
	 */
	RTSEnumerationLiteralProperties createRTSEnumerationLiteralProperties();

	/**
	 * Returns a new object of class '<em>Artifact Properties</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Artifact Properties</em>'.
	 * @generated
	 */
	ArtifactProperties createArtifactProperties();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	RTCppPropertiesPackage getRTCppPropertiesPackage();

} //RTCppPropertiesFactory
